/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Dre
Version : 
Date    : 22.04.2009
Author  : 
Company : 
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 1024
*****************************************************/

#include	<mega128.h>
#include	<delay.h>
#include	"Hw.h"

unsigned char	DelayCnt;
unsigned long	ProgArea[130];
unsigned char	RxByteCnt;
unsigned long	ProgWord;
unsigned char	ProgAdr;
unsigned char	MemoryClass;
unsigned char	RxTout;
unsigned short	SecCnt;
unsigned short	Freq;
unsigned short	Ampl;
unsigned short	AI[8];
unsigned short	Coeff;
unsigned short	Size;

bit	NeedProg;
bit	SecFlg;

// USART1 Receiver interrupt service routine
interrupt [USART1_RXC] void usart1_rx_isr(void)
{
	char dat;

	PORTG &= ~0x08;
	dat = UCSR1A;
	dat = UDR1;
//	UDR1 = dat;
	RxTout = 3;
	if ((dat & 0x80) != 0)
	{
		MemoryClass = dat & 0x7f; 
		RxByteCnt = 0;
	}
	else
	{
		if (MemoryClass == 0)
		{
			if (RxByteCnt < 8)
			{
				ProgWord = (ProgWord << 4) | dat;
				RxByteCnt++;
			}
			else
			{
				ProgAdr = (ProgAdr << 4) | dat; 
				RxByteCnt++;
			}
			if (RxByteCnt == 10)
			{
				if (ProgAdr < 128)
				{
					ProgArea[ProgAdr] = ProgWord;
				}
				RxByteCnt = 11;
			}
		}
		if (MemoryClass == 2)
		{
			if (RxByteCnt < 8)
			{
				ProgWord = (ProgWord << 4) | dat;
				RxByteCnt++;
			}
			else
			{
				ProgAdr = 0x80 | dat; 
				RxByteCnt++;
			}
			if (RxByteCnt == 9)
			{
				if (ProgAdr < 130)
				{
					ProgArea[ProgAdr] = ProgWord;
				}
				RxByteCnt = 11;
			}
		}
	}
	PORTG |= 0x08;
}

// USART1 Transmitter interrupt service routine
interrupt [USART1_TXC] void usart1_tx_isr(void)
{
	UCSR1B &= ~040;
}

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
	PORTG &= ~0x10;
	OCR1A += 1000;
	if (DelayCnt != 0)
		DelayCnt--;
	if (RxTout != 0)
	{
		RxTout--;
		if (RxTout == 0)
		{
			NeedProg = 1;
		}
	}
	if (SecCnt != 0)
		SecCnt--;
	else
	{
		SecCnt = 250;
		SecFlg = 1;
	}
	PORTG |= 0x10;
}

void
Wdog(void)
{
	#asm("wdr")
}

void
Delay(int ValmS)
{
	DelayCnt = ValmS;
	while (DelayCnt != 0)
	{
		Wdog();
	} 
}

void
Sel(void)
{
	PROG_DDR |= SD_BIT; 
	PROG_PORT &= ~SD_BIT;	// -_
	PROG_PORT |= SD_BIT;	// _-
	PROG_PORT &= ~SD_BIT;	// -_
}

void
Desel(void)
{
	PROG_DDR |= SD_BIT; 
	PROG_PORT &= ~SD_BIT;	// -_
	PROG_PORT |= SD_BIT;	// _-
	PROG_PORT &= ~SD_BIT;	// -_
	PROG_PORT |= SD_BIT;	// _-
}

void
ToggleClk(void)
{
	if ((PROG_PORT & SC_BIT) != 0)
		PROG_PORT &= ~SC_BIT;	// -_
	else
		PROG_PORT |= SC_BIT;	// _-
}

void
ReadWord(unsigned long* Dest, unsigned char Addr)
{
	unsigned char	BitCnt;
	unsigned long	Val = 0;
	
	PROG_PORT &= ~SD_BIT;
	ToggleClk();
	Sel();
	ToggleClk();	// Latch sel D = 0
	ToggleClk();	// Latch read bit D = 0
	for (BitCnt = 0; BitCnt < 8; BitCnt++)
	{
		if ((Addr & 0x80) != 0)
			PROG_PORT |= SD_BIT;
		else
			PROG_PORT &= ~SD_BIT;
		ToggleClk();	// Latch address bit
	}
	//
	PROG_DDR &= ~SD_BIT;	// Set input mode
	// 
	for (BitCnt = 0; BitCnt < 32; BitCnt++)
	{
		ToggleClk();
		Val = Val << 1;
		if ((PROG_PIN & SD_BIT) != 0)
			Val |= 0x01;
	}
	ToggleClk();
	*Dest = Val;
}

void
WriteArea(unsigned long* Src, unsigned char Addr, unsigned char Len)
{
	unsigned char	BitCnt;
	unsigned char	WordCnt;
	unsigned long	Val;
	
	PROG_PORT &= ~SD_BIT;
	ToggleClk();
	Sel();
	ToggleClk();	// Latch sel D = 0
	PROG_PORT |= SD_BIT;
	ToggleClk();	// Latch write bit D = 1
	for (BitCnt = 0; BitCnt < 8; BitCnt++)
	{
		if ((Addr & 0x80) != 0)
			PROG_PORT |= SD_BIT;
		else
			PROG_PORT &= ~SD_BIT;
		Addr = Addr << 1;
		ToggleClk();	// Latch address bit
	}
	for (WordCnt = 0; WordCnt < Len; WordCnt++)
	{
		Wdog();
		Val = *Src;
		Src++;
		for (BitCnt = 0; BitCnt < 32; BitCnt++)
		{
			if ((Val & 0x80000000) != 0)
				PROG_PORT |= SD_BIT;
			else
				PROG_PORT &= ~SD_BIT;
			Val = Val << 1;
			ToggleClk();
		}
		delay_us(25);
	}
	Desel();
	ToggleClk();	// Latch desel D = 1
}

static	unsigned short
read_adc(unsigned char adc_input)
{
	ADMUX = adc_input;
	// Start the AD conversion
	ADCSRA |= 0x40;
	// Wait for the AD conversion to complete
	while ((ADCSRA & 0x10)==0)
	{
		#asm("wdr")
	}
	ADCSRA |= 0x10;
	return ADCW;
}

static	void
MajorAi(unsigned short* Bf)
{
	unsigned short	Val;

	Val = Bf[0] + Bf[1] + Bf[2];
	if ((Val % 3) > 1)
		Val = Val / 3 + 1;
	else
		Val = Val / 3;
	Bf[3] =  Val;
}

//                 xf   frequency      amplitude
// 0x40040FA0  0 1 00 0000000001000 000111110100000
void
SetLfo(void)
{
	ProgArea[0x00] = 0x40000000 | ((unsigned long)(Freq & 0x1FFF) << 15) | (Ampl & 0x7FFFF); 
	WriteArea(&ProgArea[0], 0, 1);
}

void
SetDelay(void)
{
	ProgArea[0x05] = 0x00030002 | ((unsigned long)(Coeff & 0x7F) << 24) + Size;;
	ProgArea[0x06] = 0x00400002;
	ProgArea[0x07] = 0x7F000002 + Size;
	WriteArea(&ProgArea[0x05], 5, 3);
}

void main(void)
{
	unsigned short	CH0, CH1;
	InitHw();
	// debug
	for (ProgAdr = 0; ProgAdr < 128; ProgAdr++)
	{
		ProgArea[ProgAdr] = 0x00030000;	// fill by nop's
		Wdog();
	}
	//
	ProgArea[0x00] = 0x40040FA0;
	ProgArea[0x01] = 0x40048FA0;
	ProgArea[0x02] = 0x00030000;
	ProgArea[0x03] = 0x00030000;
	ProgArea[0x04] = 0x40000001;
	ProgArea[0x05] = 0x00034002;
	ProgArea[0x06] = 0x00400002;
	ProgArea[0x07] = 0x7F004002;
	ProgArea[0x08] = 0x7F400001;
	ProgArea[0x09] = 0x40000000;
	ProgArea[0x0A] = 0x00404003;
	ProgArea[0x0B] = 0x00004205;
	ProgArea[0x0C] = 0x54234205;
	ProgArea[0x0D] = 0x40234206;
	ProgArea[0x0E] = 0x7F400000;
	ProgArea[0x0F] = 0x00000000;
	ProgArea[0x10] = 0x00000040;
	ProgArea[0x11] = 0x00000080;
	ProgArea[0x12] = 0x000000C0;
	ProgArea[0x13] = 0x00000100;
	ProgArea[0x14] = 0x00000140;
	ProgArea[0x15] = 0x00000180;
	ProgArea[0x16] = 0x000001C0;
	ProgArea[0x17] = 0x00000200;
	ProgArea[0x18] = 0x00000240;
	ProgArea[0x19] = 0x00000280;
	ProgArea[0x1A] = 0x000002C0;
	ProgArea[0x1B] = 0x00000300;
	ProgArea[0x1C] = 0x00000340;
	ProgArea[0x1D] = 0x00000380;
	ProgArea[0x1E] = 0x000003C0;
   //
	ProgArea[0x80] = 0x00000002;
	ProgArea[0x81] = 0x00000000;
	NeedProg = 1;
	// End debug		
	// Global enable interrupts
	#asm("sei")
	Delay(250);	
	_RESET_PORT |= _RESET_BIT;
	//	
	while (1)
	{
		Wdog();
		if (NeedProg)
		{
			NeedProg = 0;
			_EXT_PORT &= ~_EXT_BIT;
			Delay(2);	
			WriteArea(&ProgArea[0x80], 0x80, 2);
			WriteArea(&ProgArea[0], 0, 128);
		}
		if (SecFlg == 1)
		{
			SecFlg = 0;
			AI[0] = read_adc(0);
			AI[0] = read_adc(0);
			AI[1] = read_adc(0);
			AI[2] = read_adc(0);
			MajorAi(&AI[0]);
			AI[4] = read_adc(1);
			AI[4] = read_adc(1);
			AI[5] = read_adc(1);
			AI[6] = read_adc(1);
			MajorAi(&AI[4]);
			CH0 = AI[3];
			CH1 = AI[7];
			Freq = CH0;// >> 2;
			if (Freq == 0)
				Freq++;
			Ampl = CH1 << 2;
			if (Ampl == 0)
				Ampl++;
			SetLfo();
			Coeff = CH0 >> 3;
			Size = CH1 << 4;
			SetDelay();
		}
	}
}
