#include	<mega128.h>

void
InitHw(void)
{
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTA = 0xFF;
	DDRA = 0x00;
	// Port B initialization
	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
	// State7=1 State6=1 State5=1 State4=1 State3=1 State2=0 State1=1 State0=1 
	PORTB = 0xFB;
	DDRB = 0xFF;
	// Port C initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTC = 0xFF;
	DDRC=0x00;
	// Port D initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=1 State2=P State1=P State0=P 
	PORTD = 0xFF;
	DDRD = 0x08;
	// Port E initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTE = 0xFF;
	DDRE = 0x00;
	// Port F initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
	PORTF = 0xFF;
	DDRF = 0x00;
	// Port G initialization
	// Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
	// State4=0 State3=0 State2=0 State1=0 State0=0 
	PORTG = 0x00;
	DDRG = 0x1F;
	// Timer/Counter 0 initialization
	// Clock source: System Clock
	// Clock value: Timer 0 Stopped
	// Mode: Normal top=FFh
	// OC0 output: Disconnected
	ASSR = 0x00;
	TCCR0 = 0x00;
	TCNT0 = 0x00;
	OCR0 = 0x00;
	// Timer/Counter 1 initialization
	// Clock source: System Clock
	// Clock value: 1000,000 kHz
	// Mode: Normal top=FFFFh
	// OC1A output: Discon.
	// OC1B output: Discon.
	// OC1C output: Discon.
	// Noise Canceler: Off
	// Input Capture on Falling Edge
	// Timer 1 Overflow Interrupt: Off
	// Input Capture Interrupt: Off
	// Compare A Match Interrupt: On
	// Compare B Match Interrupt: Off
	// Compare C Match Interrupt: Off
	TCCR1A = 0x00;
	TCCR1B = 0x02;
	TCNT1H=0x00;
	TCNT1L = 0x00;
	ICR1H = 0x00;
	ICR1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;
	OCR1CH = 0x00;
	OCR1CL = 0x00;
	// Timer/Counter 2 initialization
	// Clock source: System Clock
	// Clock value: Timer 2 Stopped
	// Mode: Normal top=FFh
	// OC2 output: Disconnected
	TCCR2 = 0x00;
	TCNT2 = 0x00;
	OCR2 = 0x00;
	// Timer/Counter 3 initialization
	// Clock source: System Clock
	// Clock value: Timer 3 Stopped
	// Mode: Normal top=FFFFh
	// Noise Canceler: Off
	// Input Capture on Falling Edge
	// OC3A output: Discon.
	// OC3B output: Discon.
	// OC3C output: Discon.
	// Timer 3 Overflow Interrupt: Off
	// Input Capture Interrupt: Off
	// Compare A Match Interrupt: Off
	// Compare B Match Interrupt: Off
	// Compare C Match Interrupt: Off
	TCCR3A = 0x00;
	TCCR3B = 0x00;
	TCNT3H = 0x00;
	TCNT3L = 0x00;
	ICR3H = 0x00;
	ICR3L = 0x00;
	OCR3AH = 0x00;
	OCR3AL = 0x00;
	OCR3BH = 0x00;
	OCR3BL = 0x00;
	OCR3CH = 0x00;
	OCR3CL = 0x00;
	// External Interrupt(s) initialization
	// INT0: Off
	// INT1: Off
	// INT2: Off
	// INT3: Off
	// INT4: Off
	// INT5: Off
	// INT6: Off
	// INT7: Off
	EICRA = 0x00;
	EICRB = 0x00;
	EIMSK = 0x00;
	// Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK = 0x10;
	ETIMSK = 0x00;
	// USART1 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART1 Receiver: On
	// USART1 Transmitter: On
	// USART1 Mode: Asynchronous
	// USART1 Baud Rate: 31250
	UCSR1A = 0x00;
	UCSR1B = 0x98;
	UCSR1C = 0x06;
	UBRR1H = 0x00;
//	UBRR1L = 0x0F;	// 31250
	UBRR1L = 0x0C;	// 38400
	// Analog Comparator initialization
	// Analog Comparator: Off
	// Analog Comparator Input Capture by Timer/Counter 1: Off
	ACSR = 0x80;
	SFIOR = 0x00;
	// ADC initialization
	// ADC Clock frequency: 125.000 kHz
	// ADC Voltage Reference: AREF pin
	ADMUX = 0;
	ADCSRA = 0x87;
	// Watchdog Timer initialization
	// Watchdog Timer Prescaler: OSC/2048k
	#pragma optsize-
	WDTCR = 0x1F;
	WDTCR = 0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
}
